package 
{
	
	/**
	 * ...
	 * @author Heddjel
	 */
	import flash.geom.Point;
	import flash.utils.ByteArray;

	import Consts;
	import Level;
	
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Tilemap;
	import net.flashpunk.graphics.TiledImage;
	import net.flashpunk.FP;

	import net.pixelpracht.tmx.TmxMap;
	
	public class Map_1 extends Entity
	{
		private const TMAP_NB_W:int = 41;
		private const TMAP_NB_H:int = 45;
		
		private const TMAP_W:int = TMAP_NB_W* Consts.TLW;
		private const TMAP_H:int = TMAP_NB_H* Consts.TLH;
//		private const TMAP_BORDER_W:int = TMAP_NB_W-Consts.SCRTMxW;
//		private const TMAP_BORDER_H:int = TMAP_NB_H-Consts.SCRTMxH;
        private const TMPA_BORDER_W:int = TMAP_W - Consts.SCRW;
        private const TMPA_BORDER_H:int = TMAP_H - Consts.SCRH;
		
//		private var mtx: int = 0;
//		private var mty: int = TMAP_BORDER_H;
		
		[Embed(source = '../content/background_2.png')]
		private var tileClass1:Class;
		
		[Embed(source = '../content/map_2.tmx', mimeType = "application/octet-stream")] 
		private var mapClass1:Class;
		
		private var tm:Tilemap;
		
		public function Map_1():void 
		{
			loadTmx();
//			updPos();
            x = 0;
			y = 0;
		}
		
		public function loadTmx():void {
			tm = new Tilemap(tileClass1, TMAP_W, TMAP_H,  Consts.TLW,  Consts.TLH);
			var file:ByteArray = new mapClass1;
			var csv:String = file.readUTFBytes(file.length);
			
			var xml:XML = FP.getXML(mapClass1);
			var tmx:TmxMap = new TmxMap(xml);
			var mapCsv:String = tmx.getLayer('Map_2').toCsv(tmx.getTileSet('bg_2'));
			
			tm.loadFromString(mapCsv);
			graphic = tm;
		}
		
/*		public function moveMe(direct: uint):Boolean
		{
			var result:Boolean = false;
			var pvx:int = mtx;
			var pvy:int = mty;
			switch (direct) {
				case Consts.MVLF: mtx -= 1; break; 
				case Consts.MVRG: mtx += 1; break; 
				case Consts.MVUP: mty -= 1; break; 
				case Consts.MVDW: mty += 1; break; 
				case Consts.MVLU: mtx -= 1; mty -= 1; break; 
				case Consts.MVLD: mtx -= 1; mty += 1; break; 
				case Consts.MVRU: mtx += 1; mty -= 1; break; 
				case Consts.MVRD: mtx += 1; mty += 1; break; 
				break; 
			}
			if (mtx < 0) { mtx = 0; }
			if (mty < 0) { mty = 0; }
			if (mtx > TMAP_BORDER_W) { mtx = TMAP_BORDER_W; }
			if (mty > TMAP_BORDER_H) { mty = TMAP_BORDER_H; }
			if ((mtx != pvx) || (mty != pvy)) {
				updPos();
				result = true;
			}
			return result;
		}
*/		
		public function moveSprite(pntPrv: Point, pntNxt: Point, sprSZ: Point, phys: Point, isplayer: Boolean): Boolean
		{
			var result:Boolean = false;
			
			var nprx:int = -x + pntNxt.x;
			var npry:int = -y + pntNxt.y;
			var mvx:int = pntNxt.x - pntPrv.x;
			var mvy:int = pntNxt.y - pntPrv.y;
			var cl1:Point = new Point;
			var cl2:Point = new Point;
			
			var t1: Boolean;
			var t2: Boolean;
			
			//check solid and map bounds
			if (nprx < 0) { nprx = 0; pntNxt.x = 0; }
			if (npry < 0) { npry = 0; pntNxt.y = 0; }
			if (nprx > (TMAP_W - sprSZ.x)) { nprx = (TMAP_W - sprSZ.x); pntNxt.x = nprx + x; }
			if (npry > (TMAP_H - sprSZ.y)) { npry = (TMAP_W - sprSZ.x); pntNxt.y = npry + y; phys.x = 0; phys.y = 0; }
			if (mvx > Consts.TLW) { nprx = -x + pntPrv.x + Consts.TLW; }
			if (mvx < -Consts.TLW) { nprx = -x + pntPrv.x - Consts.TLW; }
			if (mvy > Consts.TLH) { npry = -y + pntPrv.y + Consts.TLH; }
			if (mvy < -Consts.TLH) { npry = -y + pntPrv.y - Consts.TLH; }
			mvx = pntNxt.x - pntPrv.x;
			mvy = pntNxt.y - pntPrv.y;
			if (mvx !=0) {
				cl1.x = int(nprx / Consts.TLW);
				cl1.y = int((npry + 2) / Consts.TLH);
				cl2.y = int((npry + sprSZ.y - 3) / Consts.TLH);
				if (mvx > 0) { cl1.x += 1; }
				cl2.x = cl1.x;
				if ((tm.getTile(cl1.x, cl1.y) > 9) || (tm.getTile(cl2.x, cl2.y) > 9)) {
					//trace("tx=",cl1.x
				    if (mvx < 0) { pntNxt.x = (cl1.x + 1) * Consts.TLW + x; }
				    if (mvx > 0) { pntNxt.x = (cl1.x - 1) * Consts.TLW + x; }
					if (phys.y < -50) { phys.y = -50; }
				}
    			mvx = pntNxt.x - pntPrv.x;
				nprx = -x + pntNxt.x;
			}
			if (mvy != 0) {
				cl1.y = int(npry / Consts.TLH);
				cl1.x = int((nprx + 2) / Consts.TLW);
				cl2.x = int((nprx + sprSZ.x - 3) / Consts.TLW);
				if (mvy > 0) { cl1.y += 1; }
				cl2.y = cl1.y;
				if ((tm.getTile(cl1.x, cl1.y) > 9) || (tm.getTile(cl2.x, cl2.y) > 9)) {
					if (mvy < 0) { pntNxt.y = (cl1.y + 1) * Consts.TLH + y; if (phys.y < -100) { phys.y = -100; } }
					if (mvy > 0) { pntNxt.y = (cl1.y - 1) * Consts.TLH + y; phys.x = 0; phys.y = 0; }
				}
				mvy = pntNxt.y - pntPrv.y;
				npry = -y + pntNxt.y;
			}
			if (mvy==0) {
				cl1.y = int(npry / Consts.TLH);
				cl1.x = int(nprx + 2 / Consts.TLW);
				cl2.x = int((nprx + sprSZ.x - 3) / Consts.TLW);
				cl1.y += 1;
				cl2.y = cl1.y;
				t1 = (tm.getTile(cl1.x, cl1.y) < 10);
				t2 = (tm.getTile(cl2.x, cl2.y) < 10);
				if (t1 && t2) { phys.y = 0; phys.x = 1; }
			}
			if (isplayer) {
			    if ((int(nprx / Consts.TLW) == 39) && (int(npry / Consts.TLH) == 43))
			    { (FP.world as Level).flgEnd = true; }
			}
			
			//check map moving
			if ((mvx != 0) || (mvy != 0)) {
				result = true;
				if (isplayer) {
					if ((mvx<0) && (pntNxt.x < Consts.SCRBRDW)) {
						if (x - mvx > 0) { mvx -= x; x = 0; }
						else { x -= mvx; mvx = 0; }
						pntNxt.x = pntPrv.x + mvx;
					}
					if ((mvx > 0) && (pntNxt.x > Consts.SCRW - Consts.SCRBRDW)) {
						if (x - mvx < -TMPA_BORDER_W) {	mvx -= (-TMPA_BORDER_W-x); x = -TMPA_BORDER_W; }
						else { x -= mvx; mvx = 0; }
						pntNxt.x = pntPrv.x + mvx;
					}
					if ((mvy<0) && (pntNxt.y < Consts.SCRBRDH)) {
						if (y - mvy > 0) { mvy -= y; y = 0; }
						else { y -= mvy; mvy = 0; }
						pntNxt.y = pntPrv.y + mvy;
					}
					if ((mvy > 0) && (pntNxt.y > Consts.SCRH - Consts.SCRBRDH)) {
						if (y - mvy < -TMPA_BORDER_H) {	mvy -= (-TMPA_BORDER_H-y); y = -TMPA_BORDER_H; }
						else { y -= mvy; mvy = 0; }
						pntNxt.y = pntPrv.y + mvy;
					}
				}
			}
			
			return result;
		}
		
/*		public function updPos():void 
		{
			x = -mtx *  Consts.TLW;
			y = -mty *  Consts.TLH;
		}
*/		
		public function getMaxTW():uint 
		{
			return TMAP_NB_W;
		}
		
		public function getMaxTH():uint 
		{
			return TMAP_NB_H;
		}
		
	}
	
}