package 
{
	
	/**
	 * ...
	 * @author Heddjel
	 */

	import Consts; 
	import Level; 
	import Finished;

	import flash.geom.Point;
	
	import net.flashpunk.Entity;
//	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;

	public class Warmy extends Entity
	{
		[Embed(source = '../content/warmy2.png')] private const WARMY:Class;
		public const SPRSPD:int = 35;
		public var bounds:Point = new Point(10, 10)
		public var sprWarmy:Spritemap = new Spritemap(WARMY, 10, 10);
		public var moving:uint = Consts.MVST;
		public var physics:Point = new Point(1,0);
		public var speed:Number = 80;
		public function Warmy():void
		{
			Input.define("MvL", Key.LEFT, Key.A);
			Input.define("MvR", Key.RIGHT, Key.D);
//			Input.define("MvU", Key.UP, Key.Z);
//			Input.define("MvD", Key.DOWN, Key.S);
			Input.define("MvJ", Key.UP, Key.DOWN, Key.SPACE, Key.S, Key.W, Key.Z);
			sprWarmy.add("ST", [ 0, 1, 2], SPRSPD, true);
			sprWarmy.add("LF", [ 3, 4, 5], SPRSPD, true);
			sprWarmy.add("RG", [ 6, 7, 8], SPRSPD, true);
			sprWarmy.add("UP", [ 9,10,11], SPRSPD, true);
			sprWarmy.add("DW", [18,19,20], SPRSPD, true);
			sprWarmy.add("LU", [12,13,14], SPRSPD, true);
			sprWarmy.add("LD", [21,22,23], SPRSPD, true);
			sprWarmy.add("RU", [15,16,17], SPRSPD, true);
			sprWarmy.add("RD", [24,25,26], SPRSPD, true);
			graphic = sprWarmy;
			setHitbox(bounds.x,bounds.y);
			sprWarmy.play("ST", true);
			x = Consts.TLW;
			y = 0;
		}
		override public function update():void
		{
			if ((FP.world as Level).flgEnd) { return; }
			
			const dst: Number = speed * FP.elapsed;
			var pvp:Point = new Point(x,y);
			var nxp:Point = new Point(x,y);
			var pmov:uint = moving;
			
			if (Input.check("MvL")) { nxp.x -= dst; }
			if (Input.check("MvR")) { nxp.x += dst; }
/*			if (Input.check("MvU")) { nxp.y -= dst; }
			if (Input.check("MvD")) { nxp.y += dst; } */
			
			if ((physics.x<1) && (Input.pressed("MvJ"))) {
				physics.y -= 212; physics.x += 1;
			}
			if (physics.x > 0) {
				if (physics.y < 20*Consts.GRAVITY) { physics.y += Consts.GRAVITY };
				nxp.y += physics.y * FP.elapsed;
			}
						
			if (Input.released("MvJ"))
			{
				if (physics.y < 0) { physics.y = 0; }
			}

			var xchg:int = nxp.x - pvp.x;
			var ychg:int = nxp.y - pvp.y;
			moving = Consts.MVST;
			if ((xchg != 0) || (ychg != 0)) {
				if (Level.bg_map.moveSprite(pvp, nxp, bounds, physics, true)) {
					ychg = nxp.y - pvp.y;
					if (xchg == 0) {
						if (ychg < 0) { moving = Consts.MVUP; }
						if (ychg > 0) { moving = Consts.MVDW; }
					}
					if (xchg < 0) {
						if (ychg == 0) { moving = Consts.MVLF; }
						if (ychg < 0) { moving = Consts.MVLU; }
						if (ychg > 0) { moving = Consts.MVLD; }
					}
					if (xchg > 0) {
						if (ychg == 0) { moving = Consts.MVRG; }
						if (ychg < 0) { moving = Consts.MVRU; }
						if (ychg > 0) { moving = Consts.MVRD; }
					}
				}
			};
			
			if (moving != pmov) {
				switch (moving) {
					case Consts.MVLF: sprWarmy.play("LF", true); break; 
					case Consts.MVRG: sprWarmy.play("RG", true); break; 
					case Consts.MVUP: sprWarmy.play("UP", true); break; 
					case Consts.MVDW: sprWarmy.play("DW", true); break; 
					case Consts.MVLU: sprWarmy.play("LU", true); break; 
					case Consts.MVLD: sprWarmy.play("LD", true); break; 
					case Consts.MVRU: sprWarmy.play("RU", true); break; 
					case Consts.MVRD: sprWarmy.play("RD", true); break; 
					default: sprWarmy.play("ST", true);
					break; 
				}
			}
			
			x = nxp.x;
			y = nxp.y;
			
			if ((FP.world as Level).flgEnd) { x -= 2 * Consts.TLW; FP.world.add(new Finished); }
			
		}
	}
	
}